#include "../ecl/eclib.h"

#include <setjmp.h>

#define CURRENT_EMAIL "eklhad@sis.rpslmc.edu"

extern jmp_buf main_menu;
extern char line[], qkcat[];
extern date lowdate, highdate;
extern char datemsg[], temp_textfile[], temp_10file[];
extern char fld1[], fld2[], fld3[];
extern char cur_fname[], cur_mname[], cur_lname[];
extern char cur_birthplace[];
extern struct person cur_prs;
extern long cur_prs_rowid, birth_rowid;
extern char *textfilename(), *qkdesc(), *gng_nextfile();
extern long edfile(), foldin_text(), extract_file();
extern long getdad(), getmom();
extern long searchfor(), moddate(), this_dbid;
extern short this_version;
extern date getdate();
extern struct name *getname();
extern char *shortnote();

#define SPREADMAX 50
struct SPREADDATA {
long rownum, prsid, order;
char adopt;
char filler[3];
};
extern struct SPREADDATA spreaddata[];
extern int spreadnum;

struct person {

/* implicit serial number */
date birth, death;
char sex;
char txtc1;
short txtcnt;

};

#define STRUCT_person 0
#define select_person(id) (struct person *) ZC_select_row_file(0, (long)(id), (char*)0)
#define select_copy_person(id, buf) (struct person *) ZC_select_row_file(0, (long)(id), (buf))
#define select_mem_person(l, id) (struct person *) ZC_select_row_mem((l), (long)(id), (char*)0)
#define select_copy_mem_person(l, id, buf) (struct person *) ZC_select_row_mem((l), (long)(id), (buf))
#define delete_person(id) ZC_delete_row_file(0, (long)(id))
#define delete_mem_person(l, id) ZC_delete_row_mem((l), (long)(id))
#define insupd_person(id, buf)  ZC_insupd_row_file(0, (long)(id), (buf))
#define insupd_mem_person(l, id, buf)  ZC_insupd_row_mem((l), (long)(id), (buf))

#define LOOP_person(c, t, copy) \
start_scan(c, (struct serial_inmem*)0, STRUCT_person, (char *)(copy), 0L, (char*)0); \
while(t = (struct person *)next_scan(c)) {
#define MEM_LOOP_person(c, t, x, copy) \
start_scan(c, (struct serial_inmem*)(x), STRUCT_person, (char *)(copy), 0L, (char*)0); \
while(t = (struct person *)next_scan(c)) {
#define IDX_LOOP_person(c, t, copy, lowkey, idxname) \
start_scan(c, (struct serial_inmem*)0, STRUCT_person, (char *)(copy), (long)(lowkey), (char*)(idxname)); \
while(t = (struct person *)next_scan(c)) {
#define END_LOOP_person(c) } end_scan(c);
struct name {

long prsid; /* link to person */
date start, end; /* duration over which this name is valid */
long hashval; /* for name search */
char birth; /* name at birth */
char nickname; /* just a nickname */
char search; /* searchable name */
#define NAMELEN 49
char fullname[NAMELEN];

};

#define STRUCT_name 1
#define select_name(id) (struct name *) ZC_select_row_file(1, (long)(id), (char*)0)
#define select_copy_name(id, buf) (struct name *) ZC_select_row_file(1, (long)(id), (buf))
#define select_mem_name(l, id) (struct name *) ZC_select_row_mem((l), (long)(id), (char*)0)
#define select_copy_mem_name(l, id, buf) (struct name *) ZC_select_row_mem((l), (long)(id), (buf))
#define delete_name(id) ZC_delete_row_file(1, (long)(id))
#define delete_mem_name(l, id) ZC_delete_row_mem((l), (long)(id))
#define insupd_name(id, buf)  ZC_insupd_row_file(1, (long)(id), (buf))
#define insupd_mem_name(l, id, buf)  ZC_insupd_row_mem((l), (long)(id), (buf))

#define LOOP_name(c, t, copy) \
start_scan(c, (struct serial_inmem*)0, STRUCT_name, (char *)(copy), 0L, (char*)0); \
while(t = (struct name *)next_scan(c)) {
#define MEM_LOOP_name(c, t, x, copy) \
start_scan(c, (struct serial_inmem*)(x), STRUCT_name, (char *)(copy), 0L, (char*)0); \
while(t = (struct name *)next_scan(c)) {
#define IDX_LOOP_name(c, t, copy, lowkey, idxname) \
start_scan(c, (struct serial_inmem*)0, STRUCT_name, (char *)(copy), (long)(lowkey), (char*)(idxname)); \
while(t = (struct name *)next_scan(c)) {
#define END_LOOP_name(c) } end_scan(c);
struct address {

long prsid; /* link to a person */
date start, end;
#define AFREELEN 40
char free[AFREELEN];

};

#define STRUCT_address 2
#define select_address(id) (struct address *) ZC_select_row_file(2, (long)(id), (char*)0)
#define select_copy_address(id, buf) (struct address *) ZC_select_row_file(2, (long)(id), (buf))
#define select_mem_address(l, id) (struct address *) ZC_select_row_mem((l), (long)(id), (char*)0)
#define select_copy_mem_address(l, id, buf) (struct address *) ZC_select_row_mem((l), (long)(id), (buf))
#define delete_address(id) ZC_delete_row_file(2, (long)(id))
#define delete_mem_address(l, id) ZC_delete_row_mem((l), (long)(id))
#define insupd_address(id, buf)  ZC_insupd_row_file(2, (long)(id), (buf))
#define insupd_mem_address(l, id, buf)  ZC_insupd_row_mem((l), (long)(id), (buf))

#define LOOP_address(c, t, copy) \
start_scan(c, (struct serial_inmem*)0, STRUCT_address, (char *)(copy), 0L, (char*)0); \
while(t = (struct address *)next_scan(c)) {
#define MEM_LOOP_address(c, t, x, copy) \
start_scan(c, (struct serial_inmem*)(x), STRUCT_address, (char *)(copy), 0L, (char*)0); \
while(t = (struct address *)next_scan(c)) {
#define IDX_LOOP_address(c, t, copy, lowkey, idxname) \
start_scan(c, (struct serial_inmem*)0, STRUCT_address, (char *)(copy), (long)(lowkey), (char*)(idxname)); \
while(t = (struct address *)next_scan(c)) {
#define END_LOOP_address(c) } end_scan(c);
struct prslink {

long prs1, prs2;
date start, end;
char linktype; /* H|M|F */
unsigned char adopt:1;
unsigned char from1:1;
unsigned char from2:1;
short filler;

};

#define STRUCT_prslink 3
#define select_prslink(id) (struct prslink *) ZC_select_row_file(3, (long)(id), (char*)0)
#define select_copy_prslink(id, buf) (struct prslink *) ZC_select_row_file(3, (long)(id), (buf))
#define select_mem_prslink(l, id) (struct prslink *) ZC_select_row_mem((l), (long)(id), (char*)0)
#define select_copy_mem_prslink(l, id, buf) (struct prslink *) ZC_select_row_mem((l), (long)(id), (buf))
#define delete_prslink(id) ZC_delete_row_file(3, (long)(id))
#define delete_mem_prslink(l, id) ZC_delete_row_mem((l), (long)(id))
#define insupd_prslink(id, buf)  ZC_insupd_row_file(3, (long)(id), (buf))
#define insupd_mem_prslink(l, id, buf)  ZC_insupd_row_mem((l), (long)(id), (buf))

#define LOOP_prslink(c, t, copy) \
start_scan(c, (struct serial_inmem*)0, STRUCT_prslink, (char *)(copy), 0L, (char*)0); \
while(t = (struct prslink *)next_scan(c)) {
#define MEM_LOOP_prslink(c, t, x, copy) \
start_scan(c, (struct serial_inmem*)(x), STRUCT_prslink, (char *)(copy), 0L, (char*)0); \
while(t = (struct prslink *)next_scan(c)) {
#define IDX_LOOP_prslink(c, t, copy, lowkey, idxname) \
start_scan(c, (struct serial_inmem*)0, STRUCT_prslink, (char *)(copy), (long)(lowkey), (char*)(idxname)); \
while(t = (struct prslink *)next_scan(c)) {
#define END_LOOP_prslink(c) } end_scan(c);
struct textent {

long prsid;
date when;
long offset;
long source;
char etype; /* type of entry */
char filler[3];

};

#define STRUCT_textent 4
#define select_textent(id) (struct textent *) ZC_select_row_file(4, (long)(id), (char*)0)
#define select_copy_textent(id, buf) (struct textent *) ZC_select_row_file(4, (long)(id), (buf))
#define select_mem_textent(l, id) (struct textent *) ZC_select_row_mem((l), (long)(id), (char*)0)
#define select_copy_mem_textent(l, id, buf) (struct textent *) ZC_select_row_mem((l), (long)(id), (buf))
#define delete_textent(id) ZC_delete_row_file(4, (long)(id))
#define delete_mem_textent(l, id) ZC_delete_row_mem((l), (long)(id))
#define insupd_textent(id, buf)  ZC_insupd_row_file(4, (long)(id), (buf))
#define insupd_mem_textent(l, id, buf)  ZC_insupd_row_mem((l), (long)(id), (buf))

#define LOOP_textent(c, t, copy) \
start_scan(c, (struct serial_inmem*)0, STRUCT_textent, (char *)(copy), 0L, (char*)0); \
while(t = (struct textent *)next_scan(c)) {
#define MEM_LOOP_textent(c, t, x, copy) \
start_scan(c, (struct serial_inmem*)(x), STRUCT_textent, (char *)(copy), 0L, (char*)0); \
while(t = (struct textent *)next_scan(c)) {
#define IDX_LOOP_textent(c, t, copy, lowkey, idxname) \
start_scan(c, (struct serial_inmem*)0, STRUCT_textent, (char *)(copy), (long)(lowkey), (char*)(idxname)); \
while(t = (struct textent *)next_scan(c)) {
#define END_LOOP_textent(c) } end_scan(c);
struct qknote {

long prsid;
char ntype;
#define QKNOTE_LEN 79
char note[QKNOTE_LEN];
#define QKNOTE_CAT 7 /* number of categories */

};

#define STRUCT_qknote 5
#define select_qknote(id) (struct qknote *) ZC_select_row_file(5, (long)(id), (char*)0)
#define select_copy_qknote(id, buf) (struct qknote *) ZC_select_row_file(5, (long)(id), (buf))
#define select_mem_qknote(l, id) (struct qknote *) ZC_select_row_mem((l), (long)(id), (char*)0)
#define select_copy_mem_qknote(l, id, buf) (struct qknote *) ZC_select_row_mem((l), (long)(id), (buf))
#define delete_qknote(id) ZC_delete_row_file(5, (long)(id))
#define delete_mem_qknote(l, id) ZC_delete_row_mem((l), (long)(id))
#define insupd_qknote(id, buf)  ZC_insupd_row_file(5, (long)(id), (buf))
#define insupd_mem_qknote(l, id, buf)  ZC_insupd_row_mem((l), (long)(id), (buf))

#define LOOP_qknote(c, t, copy) \
start_scan(c, (struct serial_inmem*)0, STRUCT_qknote, (char *)(copy), 0L, (char*)0); \
while(t = (struct qknote *)next_scan(c)) {
#define MEM_LOOP_qknote(c, t, x, copy) \
start_scan(c, (struct serial_inmem*)(x), STRUCT_qknote, (char *)(copy), 0L, (char*)0); \
while(t = (struct qknote *)next_scan(c)) {
#define IDX_LOOP_qknote(c, t, copy, lowkey, idxname) \
start_scan(c, (struct serial_inmem*)0, STRUCT_qknote, (char *)(copy), (long)(lowkey), (char*)(idxname)); \
while(t = (struct qknote *)next_scan(c)) {
#define END_LOOP_qknote(c) } end_scan(c);
